<?php
$lockFile = sys_get_temp_dir() . '/file.lock';

while (true) {
    // ファイルキャッシュを消す
    clearstatcache();

    // ファイルがロックされているか確認をする
    if (file_exists($lockFile)) {
        echo "ファイルがロックされています。\n";
        usleep(200);
        continue;
    }

    $isCreated = touch($lockFile);

    if ($isCreated === false) {
        // 既に作成されてしまっている場合
        echo "ファイルがロックされています。\n";
        usleep(200);
        continue;
    }

    $handle = fopen(__DIR__ . '/access_data.log', 'r+');

    // 値を取得する
    $currentCount = (int) rtrim(fgets($handle));

    // ファイルポインタを一番最初に置く
    rewind($handle);

    // + 1 した値を書き込む
    fwrite($handle, $currentCount + 1);

    // ロックファイルを消す
    unlink($lockFile);
    break;
}