<?php
$events = new \parallel\Events();

// (2) タスクのキャンセルイベントを発生させます。
$runtime2 = new \parallel\Runtime();
$future2 = $runtime2
    ->run(
        function () {
            sleep(500);
        }
    );

$events->addFuture('fire-cancel-event', $future2);

$events->setTimeout(1);

/**
 * @var \parallel\Events\Event[] $events
 */
foreach ($events as $event) {
    switch ($event->type) {
        // 読み込みが発生した場合
        case \parallel\Events\Event\Type::Read:
            echo "{$event->source} で読み込みイベントが発生しました\n";
            break;

        // 書き込みが発生した場合
        case \parallel\Events\Event\Type::Write:
            echo "{$event->source} で書き込みイベントが発生しました\n";
            break;

        // タスクがクローズした場合
        case \parallel\Events\Event\Type::Close:
            echo "{$event->source} はクローズしました。\n";
            break;

        // タスクでキャンセルが発生した場合
        case \parallel\Events\Event\Type::Cancel:
            echo "{$event->source} はキャンセルされました\n";
            break;

        // タスクが強制終了させられた場合
        case \parallel\Events\Event\Type::Kill:
            echo "{$event->source} は強制終了されました\n";
            break;

        // タスク内でエラーが発生した場合
        case \parallel\Events\Event\Type::Error:
            echo "{$event->source} でエラーが発生しました\n";
            break;
    }
}
