<?php
// チャネルを作成します。チャネル作成時に第 2 引数は任意ですが、 capacity がない場合の動作が保証されていないということもあり
// 指定することを強くおすすめします。なお、 \parallel\Channel::Infinite を指定すると自動的に必要な分だけメモリを解放していってくれます。
// チャネルに入る値が確定ではない場合、便利です。
\parallel\Channel::make(
    'test-channel',
    \parallel\Channel::Infinite
);


// 値を送るためのタスク future1 を作成します。
$future1 = \parallel\run(
    function () {
        // 既に作成されたチャネルを開きます。
        // なお、チャネルが存在しない場合 `\parallel\Channel\Error\Existence` 例外がスローされます。
        $channel = parallel\Channel::open('test-channel');

        echo "future1 の前処理\n";
        sleep(1);
        $channel
            ->send(
                "future1 から Hello World!"
            );
        echo "future1 の後処理\n";
    }
);


// 値を受け取るためのタスク future2 を作成します。
$future2 = \parallel\run(
    function (\parallel\Channel $channel) {
        // 既に作成されたチャネルを開きます。
        $channel = parallel\Channel::open('test-channel');

        echo "future2 の前処理\n";
        echo "受け取った値: " . $channel->recv() . "\n";
        echo "future2 の後処理\n";
    }
);

// future1, 2 それぞれのタスクが正常に終了するのを待機します。
$future1->value();
$future2->value();
