<?php

// Sync クラスのインスタンスを作成します。 Java だと synchronized に渡す引数のオブジェクトと同等だと思って構いません。
$sync = new \parallel\Sync();

// 値を送るためのタスク future1 を作成します。
$future1 = \parallel\run(
    function (\parallel\Sync $sync) {
        $sync(function () use (&$sync) {
            echo "future1 の前処理\n";

            // (1) タスク2 が起動するのを待ちます。
            $sync->wait();

            // (4) タスク2 へメッセージを送ります。
            $sync->set("future1 の synchronize から Hello World!");

            // (5) タスク2 がメッセージを受け取るのを待機しているので開放します。
            $sync->notify();
            echo "future1 の後処理\n";
        });
    },
    [$sync]
);


// 値を受け取るためのタスク future2 を作成します。
$future2 = \parallel\run(
    function (\parallel\Sync $sync) {
        $sync(function () use (&$sync) {
            echo "future2 の前処理\n";

            // (2) タスク2 が起動したら、タスク 1 で待機状態であるのを開放します。
            $sync->notify();

            // (3) タスク1 からメッセージが送られてくるのを待機します。
            $sync->wait();

            // (6) 受け取った値を出力します。
            echo "受け取った値" . $sync->get() . "\n";
            echo "future2 の後処理\n";
        });
    },
    [$sync]
);

// future1, 2 それぞれのタスクが正常に終了するのを待機します。
$future1->value();
$future2->value();
