<?php

$handle = fopen('php://stdout', 'w');
fwrite(
    $handle,
    "テスト出力\n"
);
<?php

// チャネルを作成します。引数は capacity をとります。 capacity はバイトではなく MiB です。
// したがってこの 8 は 8MiB をチャネルとして使用することになります。
$channel = new \parallel\Channel(8);

$handle = fopen(__FILE__, 'a');
var_dump($handle);

// 値を送るためのタスク future1 を作成します。
$future1 = \parallel\run(
    function ($fd) {
        echo "future1 の前処理\n";
        var_dump($fd);
        fwrite(fopen('php://fd/' . $fd, 'a'), 'hogehoge');
        echo "future1 の後処理\n";
    },
    // クロージャに渡す引数を指定します。渡す値は配列ですが、クロージャには
    // 配列の 0 番目が第 1 引数, 1番目が第2引数, N-1 番目が 第 N 引数として展開されます。
    [$handle]
);


// future1, 2 それぞれのタスクが正常に終了するのを待機します。
$future1->value();


var_dump($handle);
