<?php

$server = new Swoole\WebSocket\Server('127.0.0.1', 8080, SWOOLE_PROCESS);
$server->on(
    'start',
    function () {
        echo "サーバーが起動しました。\n";
    }
);

$server->on(
    'request',
    function (Swoole\Http\Request $request, Swoole\Http\Response $response) {

        // fgets を使用できるようにするためにメモリ上に書き込むためのストリームを生成します。
        $handle = fopen('php://memory', 'rw');

        // リクエストデータをストリームに書き込みます。
        fwrite($handle, $request->getData());

        // 書き込んだものからファイルポインタの位置を最初に戻すために rewind を使用します。
        rewind($handle);

        [$method, $path, $protocol] = explode(
            // スペースで分割します。
            ' ',

            // 末端の改行を削除するために rtrim を使用します
            rtrim(
                // 書き込んだ 1 行目を取得するために fgets を使用します。
                fgets($handle)
            ),

            // GET[ ]/?key=value[ ]HTTP/1.1 のように 3 分割であるため、第二引数を 3 に指定します。
            3
        );

        //
        $formattedMethod = strtoupper($method);

        // GET の場合
        if ($formattedMethod === 'GET') {
            // ファイルアップロード用のフォームを出力します。
            $response->end(
                <<< _
                    <meta charset="UTF-8">
                    <form action="/" method="POST" enctype="multipart/form-data">
                        <input name="file" type="file" >
                        <button type="submit">送信</button>
                    </form>
                _
            );
        } elseif ($formattedMethod === 'POST') {
            // アップロードされたファイルを参照します。
            var_dump(
                $request->rawContent()
            );
            $response->end(
                <<< _
                    <meta charset="UTF-8">
                    <h1>POST が送信されました</h1>
                _
            );
        }
    }
);

$server->start();