<?php
// go 関数内でコルーチンを有効にする
Swoole\Runtime::enableCoroutine();

// 処理時間を計測するために microtime を呼び出す
$start = microtime(true);

// 終了するまで待機する
Co\run(function () {
    // 予め Redis にデータを投入する
    $redis = new Redis();
    $redis->connect('127.0.0.1', 6379);
    $redis->set(
        'awesome',
        'swoole'
    );

    // 100 回ループさせる
    for ($i = 0; $i < 100; $i++) {
        go(function () {
            // Redis の接続を確立する
            $redis = new Redis();
            $redis->connect('127.0.0.1', 6379);
            // Redis から 100 回値を取得する
            for ($i = 0; $i < 100; $i++) {
                assert($redis->get('awesome') === 'swoole');
            }
        });
    }
});

// 計測時間を出力します。
echo '計測時間: ' . (microtime(true) - $start) . '秒';