<?php

sleep(5);

// 経過時間を計測する
$start = microtime(true);

Co\run(function() {
    // データベースへの接続を設定する
    $connection = [
        'host' => 'php-asyncbook-test-mysql',
        'user' => 'test',
        'password' => 'test',
        'database' => 'test'
    ];
    $mysql = new Swoole\Coroutine\MySQL();
    $mysql->connect($connection);

    // Swoole 公式リポジトリには記載はありませんが、予めテーブルを作っておき、後の assert を通るようにする … (※)
    $statement = $mysql->prepare(
        <<< _
        CREATE TABLE `user` (
            `id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
            PRIMARY KEY (`id`)
        ) ENGINE = InnoDB
        _
    );

    // prepare した値を実行する
    $statement->execute();

    // こちらも上記同様に assert を通すため、予めデータを一つ入れておく … (※)
    $statement = $mysql->prepare(
        <<< _
        INSERT INTO `user` (`id`) values (1)
        _
    );

    // prepare した値を実行する
    $statement->execute();

    // 100 回繰り返す
    for ($i = 0; $i < 100; $i++) {
        go(function () use ($connection) {
            $mysql = new Swoole\Coroutine\MySQL();
            $mysql->connect($connection);

            // user テーブルから値を取得してくる
            $statement = $mysql->prepare(
                <<< _
                SELECT * FROM `user`
                _
            );
            for ($i = 0; $i < 100; $i++) {
                $result = $statement->execute();
                assert(count($result) > 0);
            }
        });
    }
});

echo '計測時間: ' . (microtime(true) - $start) . ' 秒';
