<!DOCType html>
<html>
<head>
    <meta charset="UTF-8">
    <title>「<?= htmlspecialchars($room->name, ENT_QUOTES, 'UTF-8') ?>」</title>
    <style type="text/css">
        body, html {
            padding: 0;
            margin: 0;
        }
        h1 {
            padding: 20px;
            margin: 0;
        }
        .form {
            border-bottom: 3px solid #666666;
            padding-left: 20px;
            padding-bottom: 20px;
        }
        .chat {
            margin-bottom: 10px;
            border-bottom: 3px solid #cccccc;
            padding-top: 10px;
            padding-left: 20px;
            padding-bottom: 10px;
        }

        .date {
            font-size: 10px;
        }

        .actions {
            display: flex;
            justify-content: space-between;
            padding-left: 20px;
            padding-right: 20px;
            margin-top: 20px;
        }
    </style>
</head>
<body>
<div class="actions">
    <a href="/rooms">← 戻る</a>
    <div>
        <?php if ($room->user_id == $user->id) : ?>
            <form action="/rooms/delete/<?= $room->id ?>" method="POST">
                <button type="submit">削除</button>
            </form>
        <?php endif ?>
    </div>
</div>
<h1><?= htmlspecialchars($room->name, ENT_QUOTES, 'UTF-8') ?></h1>
<div class="container">
    <div class="form">
        <form onSubmit="sendMessage(); return false;">
            <input id="post" placeholder="チャットに投稿する" />
            <button type="submit">投稿</button>
        </form>
    </div>
    <div id="messages">
    </div>
</div>
<script>
    var websocket = new WebSocket('ws://localhost');

    var sendMessage = function () {
        var dom = document.querySelector('#post');

        // WebSocket 宛に送信します。
        websocket.send(dom.value);

        // 送信を終えたら空にします。
        dom.value = '';
    }

    websocket.onmessage = function (event) {
        // JSON で送られてきたデータをオブジェクトに直します。
        var received = JSON.parse(event.data);

        // DOM に反映させます。
        document.querySelector('#messages').innerHTML = '<div class="chat">' + received.name + ': ' + received.message + ' <span class="date">[' + received.date + ']</span></div>' + document.querySelector('#messages').innerHTML;
    };
</script>
</body>
</html>
