<!DOCType html>
<html>
<head>
    <meta charset="UTF-8">
    <title>ルーム一覧</title>
</head>
<body>
<h1>ルーム一覧</h1>

<?php if ($error_code === 1): ?>
    <p>ルーム名は1文字以上32文字以下にしてください。</p>
<?php endif; ?>

<?php if ($error_code === 10): ?>
    <p>ルームが存在しませんでした。</p>
<?php endif; ?>
<form action="/rooms/add" method="POST">
    <input type="text" name="name" placeholder="ルーム名" />
    <button type="submit">ルームを作成</button>
</form>
<table>
    <thead>
    <tr>
        <th>ルーム番号</th>
        <th>ルーム名</th>
        <th>削除</th>
    </tr>
    </thead>
    <tbody>
    <?php if (empty($rooms)): ?>
        <tr>
            <td colspan="2" style="text-align: center">ルームはありません</td>
        </tr>
    <?php endif ?>
    <?php foreach ($rooms as $room): ?>
        <tr>
            <td><?= $room->id ?></td>
            <td><a href="/rooms/<?= $room->id ?>"><?= htmlspecialchars($room->name, ENT_QUOTES, 'UTF-8') ?></a></td>
            <td>
                <?php if ($room->user_id == $user->id) : ?>
                    <form action="/rooms/delete/<?= $room->id ?>" method="POST">
                        <button type="submit">削除</button>
                    </form>
                <?php endif ?>
            </td>
        </tr>
    <?php endforeach ?>
    </tbody>
</table>
</body>
</html>
